
public class IntSort {

	public static int[] insert(int val, int[] list)
	{
		// Create new list
		int newlist[] = new int[list.length+1];

		int i = 0;

		// Copy first half (those less than val)
		for(i = 0; i < list.length && list[i] < val; ++i)
		{
			newlist[i] = list[i];
		}

		// Copy in new value
		newlist[i] = val;

		// Copy second half
		for(; i < list.length; ++i)  
		{
			newlist[i+1] = list[i];
		}

		return newlist;

	}

	public static int[] insertionSort(int[] list)
	{
		// Start with list of size zero
		int[] newList = new int[0];

		// Loop through the elements of list
		for (int i = 0; i < list.length; ++i)
		{
			// Insert the ith element into our new list
			newList = insert(list[i], newList);
		}

		return newList;
	}

	/**
	 * 0 -> OK
	 * 1 -> bad
	 * 2 -> very bad
	 */
	public static String int2String(int error)
	{
		String out = "";

		switch(error)
		{
		case 0:
			out = "OK";
			break;
		case 1:
			out = "BAD";
			break;
		case 2:
			out = "VERY BAD";
			break;
		default:
			out = "UNKNOWN ERROR";
		}

		return out;

	}


	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		/*
		String s1 = new String("ABC123");
		String s2 = "ABC123";
		char[] a = {'A', 'B', 'c', '1', '2', '3'};
		String s3 = new String(a);
		String s4 = "ABC" + "123";

		if(s3.equalsIgnoreCase(s4)){
			System.out.println("They are equal!");
		}

		String s5 = s3.substring(0,3);
		System.out.println(s5);
		 */
		int[] list1 = {4, 7, 1, 42, 8, 2};
		int[] list2 = insertionSort(list1);
		System.out.print("Sorted ints: ");
		for(int i = 0; i < list2.length; ++i)
		{
			System.out.print(String.valueOf(list2[i]) + " ");
		}
		System.out.println("");
		
		System.out.println("Error test: " + int2String(1) + "; " + int2String(5));
	}

}
